/*

#include "board.h"

#include <iostream>

const unsigned int* p_all = (unsigned int*)&board.all;
const unsigned int* p_rotated90 = (unsigned int*)&board.rotated_90;


BITBOARD __fastcall AttacksRank(int sq){
	__asm {
		mov		edx, ecx					// edi = sq
		and		ecx, 0xf8					// ecx = shift amount
		
		mov		eax, p_all

		cmp		ecx, 32
		jl		l0

		add		eax, 4
		sub		ecx, 32

	l0:
		
	    mov		ebx, [eax]					// compute in ebx (board.all >> (sq & 8)) & 255
		shr		ebx, cl
		and		ebx, 0xff

		shl		edx, 8						
		add		ebx, edx					// ebx = sq * 8 + ((board.all >> (sq & 8) & 255)

		mov		eax, DWORD PTR rook_attacks[ebx*8]
		mov		edx, DWORD PTR rook_attacks[ebx*8+4]
	}
}

//rook_attacks  [a][Shr(board.all       ,  a & 0xf8   ) & 0xff]
//rook_attacks90[a][Shr(board.rotated_90, (a & 7) << 3) & 0xff]

//with tiny cosmetic changes, this is the same as AttacksRank1

BITBOARD __fastcall AttacksFile(int sq){
	__asm {
		mov		edi, ecx					// edi = sq
		and		ecx, 0x07					// ecx = shift amount
		shl		ecx, 3
		
		mov		eax, p_rotated90

		cmp		ecx, 32
		jl		l0

		add		eax, 4
		sub		ecx, 32

	l0:
		
	    mov		ebx, [eax]					// compute in ebx (board.all >> (sq & 8)) & 255
		shr		ebx, cl
		and		ebx, 0xff

		shl		edi, 8						
		add		ebx, edi					// ebx = sq * 8 + ((board.all >> (sq & 8) & 255)

		mov		eax, DWORD PTR rook_attacks90[ebx*8]
		mov		edx, DWORD PTR rook_attacks90[ebx*8+4]
	}
}

//AttacksDiagA1(a) bishop_attacks[a].a1[Shr(board.diag_a1, bishop_attacks[a].shift_a1) & 0xff]
//AttacksDiagH1(a) bishop_attacks[a].h1[Shr(board.diag_h1, bishop_attacks[a].shift_h1) & 0xff]

BITBOARD AttacksDiagA1_0(int sq){
	return bishop_attacks[sq].a1[Shr(board.diag_a1, bishop_attacks[sq].shift_a1) & 0xff];
}

const unsigned int* p_diag_a1 = (unsigned int*)&board.diag_a1;
const unsigned int* p_diag_h1 = (unsigned int*)&board.diag_h1;

const unsigned int* p_bishop_attacks = (unsigned int*)bishop_attacks;

BITBOARD __fastcall AttacksDiagA1(int sq){
	__asm{
		mov		ebx, ecx						// ebx = displacement in bytes from 
		shl		ebx, 8							//		the start of bishop_attacks
		add		ebx, ecx						//		i.e. 4112 * sq
		shl		ebx, 4

		mov		eax, p_bishop_attacks
		add		eax, ebx						// now eax = bishop_attacks[sq]

		mov		ecx, [eax+2048]					// ecx = bishop_attacks[sq].shift_a1

		mov		edx, p_diag_a1

		cmp		cl, 32
		jl		LESS_32

		sub		cl, 32
		mov		ebx, [edx+4]
		shr		ebx, cl
		and		ebx, 0xff

		mov		edx, DWORD PTR [eax+ebx*8+4]
		mov		eax, DWORD PTR [eax+ebx*8]

		jmp		done

	LESS_32:
		mov		ebx, [edx]						// ebx = Shr(...) & 0xff
		mov		edx, [edx+4]
		shrd	ebx,edx, cl
		and		ebx, 0xff

		mov		edx, DWORD PTR [eax+ebx*8+4]
		mov		eax, DWORD PTR [eax+ebx*8]
	}

	done:;
}

BITBOARD __fastcall AttacksDiagH1(int sq){
	__asm{
		mov		ebx, ecx						// ebx = displacement in bytes from 
		shl		ebx, 8							//		the start of bishop_attacks
		add		ebx, ecx						//		i.e. 4112 * sq + 2048 + 8
		shl		ebx, 4

		mov		eax, p_bishop_attacks
		add		eax, ebx						// now eax = bishop_attacks[sq]
		add		eax, 2056

		mov		ecx, [eax+2048]				// ecx = bishop_attacks[sq].shift_h1

		mov		edx, p_diag_h1

		cmp		cl, 32
		jl		LESS_32

		sub		cl, 32
		mov		ebx, [edx+4]
		shr		ebx, cl
		and		ebx, 0xff

		mov		edx, DWORD PTR [eax+ebx*8+4]
		mov		eax, DWORD PTR [eax+ebx*8]

		jmp		done

	LESS_32:
		mov		ebx, [edx]						// ebx = Shr(...) & 0xff
		mov		edx, [edx+4]
		shrd	ebx,edx, cl
		and		ebx, 0xff

		mov		edx, DWORD PTR [eax+ebx*8+4]
		mov		eax, DWORD PTR [eax+ebx*8]
	}

	done:;
}


//AttacksDiagA1(a) bishop_attacks[a].a1[Shr(board.diag_a1, bishop_attacks[a].shift_a1) & 0xff]
//AttacksDiagH1(a) bishop_attacks[a].h1[Shr(board.diag_h1, bishop_attacks[a].shift_h1) & 0xff]
*/

#if 0

void test_bitboards(){
	int sq;

	/*
	board.Init("5p1k/3n4/1B3R2/5P2/2Pr1P2/8/3B4/7K b - - 0 1");
	//sq = D4;
	sq = F6;

	cout << "Attacks 1 : " << endl;
	BITBOARD at1 = AttacksFile1(sq);
	PrintBitboard(at1);
	cout << endl << "Attacks 2 : " << endl;
	PrintBitboard(AttacksFile(sq));
	*/
	

	board.Init("7K/3B4/5b2/1bP3p1/6p1/4b3/8/B1N4k b - - 0 1");
	sq = E3;

	/*
	cout << "Attacks 1 : " << endl;
	BITBOARD at1 = AttacksDiagA1_1(sq);
	PrintBitboard(at1);
	cout << endl << "Attacks 2 : " << endl;
	PrintBitboard(AttacksDiagA1(sq));

	cout << endl;

	cout << bishop_attacks[sq].shift_a1 << endl;
	int result = (board.diag_a1 >> bishop_attacks[sq].shift_a1) & 255;
	cout << result << endl;
	*/

	int errors = 0;

	BITBOARD at1;

	#if 0

	for (int i = 0; i < 64; i++){
		
		at1 = AttacksDiagA1_1(i);
		if (at1 != AttacksDiagA1(i)){
			cout << i << " doesn't match !" << endl;
			errors++ ;
		} 
		

		at1 = AttacksDiagH1_1(i);
		if (at1 != AttacksDiagH1(i)){
			cout << i << " doesn't match !" << endl;
			errors++ ;
		} 
		
					
		at1 = AttacksRank1(i);
		if (at1 != AttacksRank(i)){
			cout << i << " doesn't match !" << endl;
			errors++ ;
		}
		

		
		at1 = AttacksFile1(i);
		if (at1 != AttacksFile(i)){
			cout << i << " doesn't match !" << endl;
			errors++ ;
		}
				
	}

	#endif

	if (errors == 0)
		cout << "All OK !" << endl;
	else
		cout << errors << " mismatches" << endl;

	//PrintBitboard(bishop_attacks[sq].a1[result]);
}

#endif









