#include "contra.h"
#include "move.h"
#include <string.h>
#include <iostream>

using namespace std;

static int countermove[2][7][4096];
static int counterply[7][4096];

void ResetCounterMoves(){
	memset(countermove, 0, sizeof(countermove));
	for (int j = 0; j < 7; j++)
		for (int i = 0; i < 4096; i++)
			counterply[j][i] = 0;
}

void AddCounterMove(int move, int countermove, int wtm, int ply){
	if (counterply[Piece(move)][move&4095] <= ply){
		counterply[Piece(move)][move&4095] = ply;
		::countermove[wtm][Piece(move)][move&4095] = countermove;
	}
	
}

int GetCounterMove(int move, int wtm){
	return countermove[wtm][Piece(move)][move&4095];
}


void PrintCounterMoves(){
	int k,i;

	cout << "Counter Moves : " << endl;
	cout << "White : " << endl;
	for (k = 1; k <= 6; k++)
		for (i = 0; i < 4095; i++){
			if (countermove[1][k][i]){
				int move = i + (k << 12);
				cout << "	"; PrintMove(move); 
				cout << "	"; PrintMove(countermove[1][k][i]);
				cout << endl;
			}
		}
	cout << "Black : " << endl;
	for (k = 1; k <= 6; k++)
		for (i = 0; i < 4095; i++){
			if (countermove[0][k][i]){
				int move = i + (k << 12);
				cout << "	"; PrintMove(move); 
				cout << "	"; PrintMove(countermove[0][k][i]);
				cout << endl;
			}
		}
}
