#include "hashlist.h"
#include "board.h"
#include <iostream>

using namespace std;

/* hash list signatures list used for repetition detection */

class HashListEntry {
public:
	int n;
	HASHCODE list[128];	
};

const int HASHLIST_SIZE = 16;
const int HASHLIST_MASK = HASHLIST_SIZE - 1;

class HashList{
	
protected:

	HashListEntry list[HASHLIST_SIZE];

public:
	
	HashList();

	void Add();
	void Reset();
	int Repetition2x();
	int Repetition3x();
	void RemoveLast();
};

HashList::HashList(){
	Reset();
}

void HashList::Add(){

	int index = (int)(board.hashcode & HASHLIST_MASK);
	HashListEntry& hle = list[index];

	#if 0	
	cout << "HashListAdd :" << endl;
	board.Print();
	cout << "index = " << index << endl;

	cout << "n = " << hle.n << endl << endl;
	#endif
	

	hle.list[hle.n++] = board.hashcode;


}

void HashList::Reset(){
	for (int i = 0; i < HASHLIST_SIZE; i++)
		list[i].n = 0;
}

int HashList::Repetition2x(){
	int index = (int)(board.hashcode & HASHLIST_MASK);
	HashListEntry& hle = list[index];
	register int count = 0;
	for (register int i = 0; i < hle.n; i++)
		if (hle.list[i] == board.hashcode)
			count++;
	
	return (count >= 1);	
}

int HashList::Repetition3x(){
	int index = (int)(board.hashcode & HASHLIST_MASK);
	HashListEntry& hle = list[index];
	register int count = 0;
	for (register int i = 0; i < hle.n; i++)
		if (hle.list[i] == board.hashcode)
			count++;
	
	return (count >= 2);	
}


void HashList::RemoveLast(){
	int index = (int)(board.hashcode & HASHLIST_MASK);
	HashListEntry& hle = list[index];

	#if 0	
	cout << "HashListRemoveLast :" << endl;
	cout << "Board looks like this : " << endl;
	board.Print();

	cout << "index = " << index << endl;
	cout << "n = " << hle.n << endl;
	#endif
	

	Assert(hle.n);
	hle.n--;
}


static HashList hlist;

void HashListAdd(){
	hlist.Add();
}

void HashListReset(){
	hlist.Reset();
}


int HashListRepetition2x(){
	return hlist.Repetition2x();
}

int HashListRepetition3x(){
	return hlist.Repetition3x();
}

void HashListRemoveLast(){
	hlist.RemoveLast();
}
