#include "history.h"
#include "move.h"
#include "debug.h"
#include <string.h>
#include <iostream>

using namespace std;

int htable[2][4096];

static int maxx = 0;

void AddHistoryMove(int wtm, int depth, int move){
	//Assert(wtm == 0 || wtm == 1);
	//cout << "AddHistoryMove depth = " << depth << endl;

	//int x = htable[wtm][move&4095];

	htable[wtm][move&4095] += (depth*depth);

	#if 0
	if (htable[wtm][move&4095] > maxx){
		maxx = htable[wtm][move&4095];
		cout << "new history max : " << maxx << endl;
	}
	#endif

	//Assert(htable[wtm][move&4095] >= x);
}

void AddHistoryScores(int* first, int* last, int* score, int wtm){
	//Assert(wtm == 1 || wtm == 0);
	for (int* m = first; m < last; m++, score++){
		//cout << *score << " " << htable[wtm][From(*m)][To(*m)] << endl;
		*score += htable[wtm][*m & 4095]; // /score += history_score / 1024
	}
}

void FillHistoryScores(int* first, int* last, int* score, int wtm){
	//Assert(wtm == 1 || wtm == 0);
	for (int* m = first; m < last; m++, score++){
		//cout << *score << " " << htable[wtm][From(*m)][To(*m)] << endl;
		*score = htable[wtm][*m & 4095]; // /score += history_score / 1024
	}
}



void HistoryFindFirstMove(int* first, int* last, int* score, int wtm){
	int i = 1;
	for (int* m = first+1; m < last; m++, i++){
		if (*m == 0) continue;
		if (htable[wtm][*first & 4095]+score[0] > htable[wtm][*m & 4095]+score[i]){
			int temp = *m; *m = *first; *first = temp;
			temp = score[0]; score[0] = score[i]; score[i] = temp;
		}
	}
}

void ResetHistory(){
	memset(htable, 0, sizeof(htable));
}

void AgeHistory(){
	int wtm, i;
	int max = 0;
	for (wtm = 0; wtm < 2; wtm++)
		for (i = 0; i < 4096; i++)
			if (htable[wtm][i] > max) 
				max = htable[wtm][i];

	for (wtm = 0; wtm < 2; wtm++)
		for (i = 0; i < 4096; i++)
				htable[wtm][i] -= max;
}
