#include "move.h"
#include "board.h"
#include <string.h>
#include <iostream>

using namespace std;


const char* MoveToStr(int move){
	int from,to,piece,captured,promotion;
	static char str[12];

	char* p_str = str;

	from = From(move);
	to = To(move);
	piece = Piece(move);
	captured = Captured(move);
	promotion = Promote(move);

	switch(piece){
	case PAWN: if (captured) *p_str++ = (char)('a' + File(from)); break;
	case ROOK : *p_str++ = 'R'; break;
	case KNIGHT : *p_str++ = 'N'; break;
	case BISHOP : *p_str++ = 'B'; break;
	case QUEEN : *p_str++ = 'Q'; break;
	case KING : *p_str++ = 'K'; break;
	default : strcpy(str, "wrong piece type");return str;
	}

	if (captured) 
		*p_str++ = 'x';

	*p_str++ = (char)('a' + File(to));
	*p_str++ = Rank(to)+'1';

	if (promotion) {
		switch(promotion){
		case ROOK : *p_str++ = 'R'; break;
		case KNIGHT : *p_str++ = 'N'; break;
		case BISHOP : *p_str++ = 'B'; break;
		case QUEEN : *p_str++ = 'Q'; break;
		default : strcpy(str, "wrong piece type to promote to"); return str;
		}
	}


	#if 0
	if (captured) {
		*p_str++ = '(';
		switch(captured){
		case PAWN: *p_str++ = 'p'; break;
		case ROOK : *p_str++ = 'R'; break;
		case KNIGHT : *p_str++ = 'N'; break;
		case BISHOP : *p_str++ = 'B'; break;
		case QUEEN : *p_str++ = 'Q'; break;
		case KING : *p_str++ = 'K'; break;
		default : strcpy(str, "wrong piece type");return str;
		}
		*p_str++ = ')';
	}
	#endif
	
	*p_str++ = ' ';	
	*p_str++ = 0;
	return str;
}

void PrintMove(int move){
	int from,to,piece,captured,promotion;

	from = From(move);
	to = To(move);
	piece = Piece(move);
	captured = Captured(move);
	promotion = Promote(move);

	switch(piece){
	case PAWN: if (captured) cout << (char)('a' + File(from)); break;
	case ROOK : cout << 'R'; break;
	case KNIGHT : cout << 'N'; break;
	case BISHOP : cout << 'B'; break;
	case QUEEN : cout << 'Q'; break;
	case KING : cout << 'K'; break;
	default : cout << "wrong piece type";
	}

	if (captured) 
		cout << 'x';

	cout << (char)('a' + File(to)) << Rank(to)+1;

	if (promotion) {
		switch(promotion){
		case ROOK : cout << 'R'; break;
		case KNIGHT : cout << 'N'; break;
		case BISHOP : cout << 'B'; break;
		case QUEEN : cout << 'Q'; break;
		default : cout << "wrong piece type to promote to";
		}
	}

	if (captured) {
		cout << "(";
		switch(captured){
		case PAWN: cout << 'p'; break;
		case ROOK : cout << 'R'; break;
		case KNIGHT : cout << 'N'; break;
		case BISHOP : cout << 'B'; break;
		case QUEEN : cout << 'Q'; break;
		case KING : cout << 'K'; break;
		default : cout << "wrong piece type";
		}
		cout << ")";
	}
	
	//cout << "(" << from << ' ' << to << ' ' << piece << ' ' << captured << ' ' << promotion << ')';

	cout << ' ';	

}


// Print a move after the move was made on the board
const char* MoveToStrComplete(int move, int wtm){
	int from,to,piece,captured,promotion;
	static char str[12];

	static int m_list[256];

	char* p_str = str;

	from = From(move);
	to = To(move);
	piece = Piece(move);
	captured = Captured(move);
	promotion = Promote(move);

	switch(piece){
	case PAWN: if (captured) *p_str++ = (char)('a' + File(from)); break;
	case ROOK : *p_str++ = 'R'; break;
	case KNIGHT : *p_str++ = 'N'; break;
	case BISHOP : *p_str++ = 'B'; break;
	case QUEEN : *p_str++ = 'Q'; break;
	case KING : *p_str++ = 'K'; break;
	default : strcpy(str, "wrong piece type");return str;
	}

	if (captured) 
		*p_str++ = 'x';

	*p_str++ = (char)('a' + File(to));
	*p_str++ = Rank(to)+'1';

	if (promotion) {
		switch(promotion){
		case ROOK : *p_str++ = 'R'; break;
		case KNIGHT : *p_str++ = 'N'; break;
		case BISHOP : *p_str++ = 'B'; break;
		case QUEEN : *p_str++ = 'Q'; break;
		default : strcpy(str, "wrong piece type to promote to"); return str;
		}
	}

	if (Check(wtm)){
		if (board.GenerateAllValidMoves(m_list, wtm) == m_list)
			*p_str++ = '#';
		else
			*p_str++ = '+';
	}

	*p_str++ = ' ';	
	*p_str++ = 0;
	return str;
}



