#include "rootmove.h"
#include "tree.h"
#include "board.h"
#include <string.h>


RootInfo root_info;

void RootInfo::Init(int wtm){
	int *move;

	int* last = board.GenerateAllValidMoves(move_list, wtm);
	last_move[0] = last-move_list;

	n_moves = 0;
	memset(m, 0, sizeof(m));

	SaveBoardInfo(0);

	for (move = move_list; move < last; move++, n_moves++){
		m[n_moves].move = *move;

		#if 0
		board.Make(*move, 0, wtm);

		m[n_moves].score = -Search(-INF, INF, PLY_DEPTH, 1, 1-wtm, 1);

		board.Unmake(*move, 0, wtm);
		#endif

	}
	
	//SortMovesByScore();
}


void RootInfo::MoveToFront(int move_number){
	static RootMove tmp;
	int i;

	Assert(move_number >= 0 && move_number < n_moves);

	#if 0
	cout << "Move to front : ";
	for(i = 0; i < m[move_number].pvlen; i++) PrintMove(m[move_number].pv[i]);
	cout << endl;
	#endif

	if (move_number > 0){
		tmp = m[move_number];
		for (i = move_number-1; i >= 0; i--)
			m[i+1] = m[i];
		m[0] = tmp;
	}	
}

void RootInfo::UpdateMoveInfo(int move_number, int score, int ply, int nodes){
	Assert(move_number >= 0 && move_number < n_moves);
	
	m[move_number].nodes = nodes;
	m[move_number].score = score;
	m[move_number].plies = ply;
	memcpy(m[move_number].pv, pv[0], pvlen[0]*sizeof(int));
	m[move_number].pvlen = pvlen[0];
}

void RootInfo::SortMovesByScore(){
	RootMove tmp;

	int done = 0;
	while (!done){
		done = 1;
		for (int i = 1; i+1 < n_moves; i++)
			if (m[i].score < m[i+1].score){
				tmp = m[i]; m[i] = m[i+1]; m[i+1] = tmp;
				done = 0;
			}
	}
}

void RootInfo::SortMovesByNodes(){
	RootMove tmp;

	int done = 0;
	while (!done){
		done = 1;
		for (int i = 1; i+1 < n_moves; i++)
			if (m[i].score < m[i+1].score){
				tmp = m[i]; m[i] = m[i+1]; m[i+1] = tmp;
				done = 0;
			}
	}
}

void RootInfo::SortMovesByScoreAndNodes(){
	RootMove tmp;

	int done = 0;
	while (!done){
		done = 1;
		for (int i = 1; i+1 < n_moves; i++)
			if (m[i].score < m[i+1].score || (m[i].score == m[i+1].score && m[i].nodes < m[i+1].nodes)){
				tmp = m[i]; m[i] = m[i+1]; m[i+1] = tmp;
				done = 0;
			}
	}
}

