#include "swap.h"
#include "board.h"
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include "move.h"

using namespace std;

extern int directions[64][64];
extern BITBOARD plus1dir[64],plus7dir[64],plus8dir[64],plus9dir[64];
extern BITBOARD minus1dir[64],minus7dir[64],minus8dir[64], minus9dir[64];


//void SwapXRay(BITBOARD& attacks, int from, int direction);


int Swap2(int from, int target, int wtm);

int Swap(int from, int target, int wtm){
	static int swap_list[32];
	int attacked_piece;
	int n;
	int square, direction;
	int sign;

	//return piece_v[Abs(PieceOnSquare(target))] - piece_v[Abs(PieceOnSquare(from))];
	

	BITBOARD attacks = Or(Or(Or(Or(Or(And(wpawn_attacks[target], board.bPawns),
			 			     And(bpawn_attacks[target], board.wPawns)),
							And(knight_attacks[target], Or(board.bKnights,board.wKnights))),
							And(AttacksBishop(target), board.bishops_queens)),
							And(AttacksRook(target), board.rooks_queens)),
							And(king_attacks[target], Or(board.bKing,board.wKing)));

	attacked_piece = Abs(PieceOnSquare(target));

	// special case I'm using : from == to means no capture, but I want to see
	// if the piece on that square can be captured easily
	if (from == target)
		attacked_piece = 0;

	n = 0;
	
	// start exchange by placing first piece 	
	swap_list[n++] = piece_v[attacked_piece];
	attacks &= ~set_mask[from];

	attacked_piece = Abs(PieceOnSquare(from));


	direction = directions[target][from];
	if (direction)
		SwapXRay(attacks, from, direction);

	sign = -1;

	int color = NextSide(wtm);

	//PrintBitboard(attacks);


	while (attacks) {

		if (color){
			if (And(board.wPawns,attacks))
				square = FirstOne(And(board.wPawns,attacks));
			else if (And(board.wKnights,attacks))
				square = FirstOne(And(board.wKnights,attacks));
			else if (And(board.wBishops,attacks))
				square = FirstOne(And(board.wBishops,attacks));
			else if (And(board.wRooks,attacks))
				square = FirstOne(And(board.wRooks,attacks));
			else if (And(board.wQueens,attacks))
				square = FirstOne(And(board.wQueens,attacks));
			else if (And(board.wKing,attacks))
				square = FirstOne(And(board.wKing,attacks));
			else break;
		} else {
			if (And(board.bPawns,attacks))
				square = FirstOne(And(board.bPawns,attacks));
			else if (And(board.bKnights,attacks))
				square = FirstOne(And(board.bKnights,attacks));
			else if (And(board.bBishops,attacks))
				square = FirstOne(And(board.bBishops,attacks));
			else if (And(board.bRooks,attacks))
				square = FirstOne(And(board.bRooks,attacks));
			else if (And(board.bQueens,attacks))
				square = FirstOne(And(board.bQueens,attacks));
			else if (And(board.bKing,attacks))
				square = FirstOne(And(board.bKing,attacks));
			else break;
		}

		swap_list[n] = swap_list[n-1] + (sign < 0 ? -piece_v[attacked_piece] : piece_v[attacked_piece]);
		attacked_piece = Abs(PieceOnSquare(square));

		#if 0

		cout << "--" << endl;

		PrintBitboard(attacks);
		PrintBitboard(~set_mask[square]);

		#endif

		attacks &= ~set_mask[square];

		//PrintBitboard(attacks);

		direction = directions[target][square];
		if (direction)
			SwapXRay(attacks, square, direction);

		//PrintBitboard(attacks);

		color = NextSide(color);
		sign = -sign;

		n++;
	}


	n--;
	sign = (n&1) ? -1 : 1;

	int last_capture = n;

	while (n){
		if (sign < 0){
			if (swap_list[n] <= swap_list[n-1])
				swap_list[n-1] = swap_list[n];
			else 
				last_capture = n - 1;
		} else {
			if (swap_list[n] >= swap_list[n-1])
				swap_list[n-1] = swap_list[n];
			else 
				last_capture = n - 1;
		}
		n--;
		sign = -sign;
	}


	#if 0
	int v0 = Swap2(from, target, wtm);

	if (v0 != swap_list[0]) {
		cout << "Swap values don't match !" << endl;
		//Assert(false);
		exit(-1);
	} else {
		//cout << "Swap values match !" << endl;
	}
	#endif
	
	return swap_list[0];
}

/*
	My Swap() idea :
	
	keep a list of pieces attacking target

	color = 1-wtm

	while (list !empty){
		select the next attacker of color, if none exists break
		remove it from the list
		add to the list the next attacker on that direction 
	}

	// Note : by removing a piece, only rook/bishop/queen attacks needs to be checked

	do minmax
*/


int FindNextAttacker(int square, int direction);

int Swap2(int from, int target, int wtm){
	static int swap_list[32];
	int attacked_piece;
	int n,i;
	int square, direction;
	int sign;

	static int attackers_list[8]; // we can have max 8 of those

	BITBOARD attacks = Or(AttacksTo(target, 0) , AttacksTo(target, 1));

	attacked_piece = Abs(PieceOnSquare(target));

	n = 0;
	
	// start exchange by placing first piece 	
	swap_list[n++] = piece_v[attacked_piece];
	attacks &= ~set_mask[from];

	direction = directions[target][from];
	if (direction)
		SwapXRay(attacks, from, direction);

	attacked_piece = Abs(PieceOnSquare(from));



	//PrintBitboard(attacks);

	int n_attackers = 0;
	while (attacks){
		square = FirstOne(attacks);
		ClearFirstOne(attacks);
		attackers_list[n_attackers++] = square;
	}

	#if 0

	static int times = 0;
	times++;
	cout << "swap counter : " << times << endl;

	const int counter_v = 44;


	if (times == counter_v){
		cout << "Beginning Swap2 : " << endl;
		board.Print();

		cout << "from = " << (char)(File(from)+'a') << (char)(Rank(from)+'1') << " ";
		cout << "to = " << (char)(File(target)+'a') << (char)(Rank(target)+'1');
		cout << endl;
		
		for (i = 0; i < n_attackers; i++)
			cout << (char)(File(attackers_list[i])+'a') << (char)(Rank(attackers_list[i])+'1') << " ";
		cout << endl;
	}

	#endif


	sign = -1;

	int color = NextSide(wtm);

	while (n_attackers > 0) {

		// Step 1 : select the attacker, break if no valid attacker found
		int attacker = -1;
		int attacker_v = 99999999;
		if (color){

			for (i = 0; i < n_attackers; i++){
				int piece = PieceOnSquare(attackers_list[i]);
				if (piece > 0)
					if (piece_v[piece] < attacker_v){
						attacker = i;
						attacker_v = piece_v[piece];
					}
			}
			if (attacker < 0) break;

		} else {

			for (i = 0; i < n_attackers; i++){
				int piece = -PieceOnSquare(attackers_list[i]);
				if (piece > 0)
					if (piece_v[piece] < attacker_v){
						attacker = i;
						attacker_v = piece_v[piece];
					}
			}
			if (attacker < 0) break;			
		}
	
		
		// Step 2 : update the swap list

		square = attackers_list[attacker];

		swap_list[n] = swap_list[n-1] + (sign < 0 ? -piece_v[attacked_piece] : piece_v[attacked_piece]);
		attacked_piece = Abs(PieceOnSquare(square));

		// Step 3 : remove the piece from the attackers list and add a new attacker if any
		
		int sq = FindNextAttacker(square, directions[target][square]); // new square
		
		if (sq < 0){
			if (n_attackers-1 > attacker)
				attackers_list[attacker] = attackers_list[n_attackers-1];
			n_attackers--;
		} else 
			attackers_list[attacker] = sq;

		color = NextSide(color);
		sign = -sign;

		n++;
	}


	n--;
	sign = (n&1) ? -1 : 1;

	int last_capture = n;

	while (n){
		if (sign < 0){
			if (swap_list[n] <= swap_list[n-1])
				swap_list[n-1] = swap_list[n];
			else 
				last_capture = n - 1;
		} else {
			if (swap_list[n] >= swap_list[n-1])
				swap_list[n-1] = swap_list[n];
			else 
				last_capture = n - 1;
		}
		n--;
		sign = -sign;
	}

	return swap_list[0];
}


int FindNextAttacker(int square, int direction){
		int sq = -1; // new square
		
		switch(direction){
		case -9 : if (minus9dir[square] & board.all)
					sq = LastOne(minus9dir[square] & board.all);
				 break;
		case -8 : if (minus8dir[square] & board.all)
					sq = LastOne(minus8dir[square] & board.all);
				 break;
		case -7 : if (minus7dir[square] & board.all)
					sq = LastOne(minus7dir[square] & board.all);
				 break;
		case -1 : if (minus1dir[square] & board.all)
					sq = LastOne(minus1dir[square] & board.all);
				 break;
		case +1 : if (plus1dir[square] & board.all)
					sq = FirstOne(plus1dir[square] & board.all);
				 break;
		case +7 : if (plus7dir[square] & board.all)
					sq = FirstOne(plus7dir[square] & board.all);
				 break;
		case +8 : if (plus8dir[square] & board.all)
					sq = FirstOne(plus8dir[square] & board.all);
				 break;
		case +9 : if (plus9dir[square] & board.all)
					sq = FirstOne(plus9dir[square] & board.all);
				 break;
		}

		if (sq >= 0){
			int piece = Abs(PieceOnSquare(sq));
			int dir = Abs(direction);
			if ((dir == 1 || dir == 8) && piece != ROOK && piece != QUEEN) sq = -1;
			if ((dir == 7 || dir == 9) && piece != BISHOP && piece != QUEEN) sq = -1;
		}

		return sq;
}



/*
BITBOARD SwapXRay(BITBOARD attacks, int from, int direction){
	switch (direction){
	case 1:
		return Or(attacks, And(And(AttacksRank(from),board.rooks_queens),plus1dir[from]));
	case 7:
		return Or(attacks, And(And(AttacksDiagH1(from),board.bishops_queens),plus7dir[from]));
	case 8:
		return Or(attacks, And(And(AttacksFile(from),board.rooks_queens),plus8dir[from]));
	case 9:
		return Or(attacks, And(And(AttacksDiagA1(from),board.bishops_queens),plus9dir[from]));
	case -1:
		return Or(attacks, And(And(AttacksRank(from),board.rooks_queens),minus1dir[from]));
	case -7:
		return Or(attacks, And(And(AttacksDiagH1(from),board.bishops_queens),minus7dir[from]));
	case -8:
		return Or(attacks, And(And(AttacksFile(from),board.rooks_queens),minus8dir[from]));
	case -9:
		return Or(attacks, And(And(AttacksDiagA1(from),board.bishops_queens),minus9dir[from]));
	}

	return attacks;
}
*/

void SwapXRay(BITBOARD& attacks, int from, int direction){
	register BITBOARD tmp = board.all;

	
	switch (direction){
	case +1: tmp &= plus1dir[from]; break;
	case +7: tmp &= plus7dir[from]; break;
	case +8: tmp &= plus8dir[from]; break;	
	case +9: tmp &= plus9dir[from]; break;
	case -1: tmp &= minus1dir[from]; break;
	case -7: tmp &= minus7dir[from]; break;
	case -8: tmp &= minus8dir[from]; break;
	case -9: tmp &= minus9dir[from]; break;
	default : return;
	}
	
	if (tmp){
		int sq = (direction > 0) ? FirstOne(tmp) : LastOne(tmp);

		int piece = Abs(PieceOnSquare(sq));
	
		if (((Abs(direction) == 1 || Abs(direction) == 8) && (piece == QUEEN || piece == ROOK)) ||
			((Abs(direction) == 7 || Abs(direction) == 9) && (piece == QUEEN || piece == BISHOP)))
				attacks |= set_mask[sq];
	}
}


int PinnedOnKing(int wtm, int square){
	int ray;
	
	if (wtm){
		ray = directions[square][board.white_king_sq];

		switch(Abs(ray)){
		case 1: 
			if (And(AttacksRank(square), board.wKing) != 0)
				return (And(And(AttacksRank(square), board.rooks_queens), board.black_pieces) != 0);
			else
				return 0;
		case 7:
			if (And(AttacksDiagH1(square),board.wKing) != 0)
				return (And(And(AttacksDiagH1(square), board.bishops_queens),board.black_pieces) != 0);
			else
				return 0;
		case 8:
			if (And(AttacksFile(square), board.wKing) != 0)
				return (And(And(AttacksFile(square), board.rooks_queens), board.black_pieces) != 0);
			else
				return 0;
		case 9:
			if (And(AttacksDiagA1(square),board.wKing) != 0)
				return (And(And(AttacksDiagA1(square), board.bishops_queens),board.black_pieces) != 0);
			else
				return 0;
		}
	} else {

		ray = directions[square][board.black_king_sq];

		switch(Abs(ray)){
		case 1: 
			if (And(AttacksRank(square), board.bKing) != 0)
				return (And(And(AttacksRank(square), board.rooks_queens), board.white_pieces) != 0);
			else
				return 0;
		case 7:
			if (And(AttacksDiagH1(square),board.bKing) != 0)
				return (And(And(AttacksDiagH1(square), board.bishops_queens), board.white_pieces) != 0);
			else
				return 0;
		case 8:
			if (And(AttacksFile(square), board.bKing) != 0)
				return (And(And(AttacksFile(square), board.rooks_queens), board.white_pieces) != 0);
			else
				return 0;
		case 9:
			if (And(AttacksDiagA1(square),board.bKing) != 0)
				return (And(And(AttacksDiagA1(square), board.bishops_queens), board.white_pieces) != 0);
			else
				return 0;
		}

	}

	return 0;
}


BITBOARD InterposeSquares(int check_direction, int king_square, int checking_square){
	BITBOARD target;

	switch(check_direction){
	case +1:
		target = Xor(plus1dir[king_square-1], plus1dir[checking_square]);
		break;
	case +7:
		target = Xor(plus7dir[king_square-7], plus7dir[checking_square]);
		break;
	case +8:
		target = Xor(plus8dir[king_square-8], plus8dir[checking_square]);
		break;
	case +9:
		target = Xor(plus9dir[king_square-9], plus9dir[checking_square]);
		break;
	case -1:
		target = Xor(minus1dir[king_square+1], minus1dir[checking_square]);
		break;
	case -7:
		target = Xor(minus7dir[king_square+7], minus7dir[checking_square]);
		break;
	case -8:
		target = Xor(minus8dir[king_square+8], minus8dir[checking_square]);
		break;
	case -9:
		target = Xor(minus9dir[king_square+9], minus9dir[checking_square]);
		break;
	default:
		target = 0;
		break;
	}

	return target;
}
